
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Curriculum_standardsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const curriculum_standards = await db.curriculum_standards.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        competency_area: data.competency_area
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await curriculum_standards.setSubject( data.subject || null, {
            transaction,
        });
        
        await curriculum_standards.setGrade_level( data.grade_level || null, {
            transaction,
        });
        

        

        

        return curriculum_standards;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const curriculum_standardsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                competency_area: item.competency_area
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const curriculum_standards = await db.curriculum_standards.bulkCreate(curriculum_standardsData, { transaction });

        // For each item created, replace relation files
        

        return curriculum_standards;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const curriculum_standards = await db.curriculum_standards.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.competency_area !== undefined) updatePayload.competency_area = data.competency_area;
        
        
        updatePayload.updatedById = currentUser.id;

        await curriculum_standards.update(updatePayload, {transaction});

        
        
        if (data.subject !== undefined) {
            await curriculum_standards.setSubject(
              
              data.subject,
              
              { transaction }
            );
        }
        
        if (data.grade_level !== undefined) {
            await curriculum_standards.setGrade_level(
              
              data.grade_level,
              
              { transaction }
            );
        }
        

        
        

        

        return curriculum_standards;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const curriculum_standards = await db.curriculum_standards.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of curriculum_standards) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of curriculum_standards) {
                await record.destroy({transaction});
            }
        });


        return curriculum_standards;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const curriculum_standards = await db.curriculum_standards.findByPk(id, options);

        await curriculum_standards.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await curriculum_standards.destroy({
            transaction
        });

        return curriculum_standards;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const curriculum_standards = await db.curriculum_standards.findOne(
            { where },
            { transaction },
        );

        if (!curriculum_standards) {
            return curriculum_standards;
        }

        const output = curriculum_standards.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.skills_standard = await curriculum_standards.getSkills_standard({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.subject = await curriculum_standards.getSubject({
            transaction
        });
        
        
        output.grade_level = await curriculum_standards.getGrade_level({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.subjects,
        as: 'subject',
        
        where: filter.subject ? {
          [Op.or]: [
            { id: { [Op.in]: filter.subject.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.subject.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.grade_levels,
        as: 'grade_level',
        
        where: filter.grade_level ? {
          [Op.or]: [
            { id: { [Op.in]: filter.grade_level.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.grade_level.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'curriculum_standards',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'curriculum_standards',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.competency_area) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'curriculum_standards',
                        'competency_area',
                        filter.competency_area,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.curriculum_standards.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'curriculum_standards',
                        'code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.curriculum_standards.findAll({
            attributes: [ 'id', 'code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.code,
        }));
    }

    
};

